//---------------------------------------------------------------------------
#ifndef BMP2PPMainH
#define BMP2PPMainH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Menus.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Buttons.hpp>
#include "sampreg.h"
#include <vcl\Mask.hpp>
#include <vcl\ComCtrls.hpp>
//---------------------------------------------------------------------------
#include "BMP2PPReadMeForm.h"
#include "BMP2PPBitmapForm.h"
#include "BMP2PPProgressForm.h"
#include <vcl\Dialogs.hpp>
#include "tclipboardviewer.h"
class TBMP2PPMainForm : public TForm
{
__published:	// IDE-managed Components
	TMainMenu *MainMenu1;
	TMenuItem *FileMainMenu;
	TMenuItem *ExitMenu;
	TBevel *Bevel1;
	TPanel *SpeedBarPanel;
	TSpeedButton *BitmapOpenSpeedButton;
	TBevel *Bevel2;
	TLabel *Label1;
	TLabel *Label2;
	TBitBtn *BitmapFullWindowBitBtn;
	TBitBtn *PowerPaintFullWindowBitBtn;
	TGroupBox *ColoursGroupBox;
	TComboBox *InPaletteComboBox;
	TLabel *Label3;
	TLabel *Label9;
	TSpinEdit *GammaSpinEdit;
	TLabel *Label10;
	TSpinEdit *BrightnessSpinEdit;
	TCheckBox *GreyscaleCheckBox;
	TGroupBox *DitherGroupBox;
	TLabel *Label4;
	TComboBox *DitherComboBox;
	TLabel *Label5;
	TSpinEdit *MaxErrorSpinEdit;
	TLabel *Label6;
	TSpinEdit *NoiseLevelSpinEdit;
	TLabel *Label12;
	TMaskEdit *DitheringWeightsMaskEdit;
	TGroupBox *ScaleGroupBox;
	TLabel *Label8;
	TComboBox *ScaleComboBox;
	TCheckBox *InterpolateCheckBox;
	TGroupBox *MiscellaneousGroupBox;
	TLabel *Label7;
	TComboBox *CentreComboBox;
	TComboBox *FilterComboBox;
	TLabel *Label11;
	TCheckBox *StretchBitmapCheckBox;
	TCheckBox *StretchPowerPaintCheckBox;
	TStatusBar *StatusBar;
	TPanel *BitmapImagePanel;
	TImage *BitmapImage;
	TPanel *PowerPaintImagePanel;
	TImage *PowerPaintImage;
	TBitBtn *BMP2PPBitBtn;
	TBitBtn *PP2BMPBitBtn;
	TSpeedButton *BitmapSaveSpeedButton;
	TSpeedButton *BitmapCopySpeedButton;
	TSpeedButton *BitmapPasteSpeedButton;
	TSpeedButton *PowerPaintOpenSpeedButton;
	TSpeedButton *PowerPaintSaveSpeedButton;
	TSpeedButton *PowerPaintCopySpeedButton;
	TSpeedButton *PowerPaintPasteSpeedButton;
	TOpenDialog *OpenDialogue;
	TSaveDialog *SaveDialogue;
	TMenuItem *HelpMainMenu;
	TMenuItem *AboutMenu;
	TMenuItem *BitmapOpenMenu;
	TMenuItem *BitmapSaveMenu;
	TMenuItem *PowerPaintOpenMenu;
	TMenuItem *PowerPaintSaveMenu;
	TMenuItem *N1;
	TMenuItem *N2;
	TMenuItem *EditMainMenu;
	TMenuItem *BitmapCopyMenu;
	TMenuItem *BitmapPasteMenu;
	TMenuItem *PowerPaintCopyMenu;
	TMenuItem *PowerPaintPasteMenu;
	TMenuItem *N3;
	TMenuItem *ReadMeMenu;
	TCheckBox *MonochromeCheckBox;
	TClipboardViewer *ClipboardViewer;
	void __fastcall StretchCheckBoxClick(TObject *Sender);
	void __fastcall FullWindowBitBtnClick(TObject *Sender);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall ExitItemClick(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall BitmapOpenItemClick(TObject *Sender);
	void __fastcall BitmapSaveItemClick(TObject *Sender);
	void __fastcall BitmapCopyItemClick(TObject *Sender);
	void __fastcall BitmapPasteItemClick(TObject *Sender);
	void __fastcall AboutItemClick(TObject *Sender);
	void __fastcall PowerPaintOpenItemClick(TObject *Sender);
	void __fastcall PowerPaintSaveItemClick(TObject *Sender);
	void __fastcall PowerPaintCopyItemClick(TObject *Sender);
	void __fastcall PowerPaintPasteItemClick(TObject *Sender);
	void __fastcall PP2BMPBitBtnClick(TObject *Sender);
	void __fastcall BMP2PPBitBtnClick(TObject *Sender);
	void __fastcall ReadMeItemClick(TObject *Sender);
	void __fastcall DrawClipboard(TObject *Sender);
private:	// User declarations
	void PowerPaintToBitmap (Graphics::TBitmap *bitmap);
	bool ReadOptionsFromIniFile (void);
    void SaveOptionsToIniFile (void);
    void __fastcall OnHint (TObject *Sender);
	TBitmapForm *FullScreenBitmapForm;
    TBitmapForm *FullScreenPowerPaintForm;
    TReadMeForm *ReadMeForm;
    bool FullScreenBitmapFormShowing;
    bool FullScreenPowerPaintFormShowing;
    byte *PowerPaintData;
    int PowerPaintDataLength;
    byte *Palettes[4];
    int *Filters[8];
    UINT cfPowerPaint;
    TProgressForm *ProgressForm;
public:		// User declarations
	__fastcall TBMP2PPMainForm(TComponent* Owner);
    void BitmapFormDestroyed (TBitmapForm *bitmapForm);
    int bmp2ppCallback (char *message,int progress);
};
//---------------------------------------------------------------------------
extern TBMP2PPMainForm *BMP2PPMainForm;
//---------------------------------------------------------------------------
#endif
